// EventHandler.hxx - part of the murx project
//
// (c) 2005 Kai Hildebrandt
//
// ---------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
// ---------------------------------------------------------------------

// pattern for signals in OO from:
// http://www.cs.wustl.edu/~schmidt/signal-patterns.html

#ifndef MURX_EVENTHANDLER_HXX
#define MURX_EVENTHANDLER_HXX

namespace Murx
{
    class EventHandler
    {
    public:
        virtual ~EventHandler() {}

        // hook method for the signal hook method
        virtual int handle_signal (int signum) = 0;

        // ...
    };
}

#endif /* MURX_EVENTHANDLER_HXX */
