// Match.cxx - part of the murx project
//
// (c) 2004 by Kai Hildebrandt, Thomas Stauss
//
// ---------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
// ---------------------------------------------------------------------

#include "MatchData.hxx"
#include "Match.hxx"


namespace Murx
{
    
    Match::Match()
    {
    }


    std::string Match::get_action() const
    {
        return action;
    }
    void Match::set_action (std::string action)
    {
        this->action = action;
    }

    
    bool Match::was_complete_match() const
    {
        return complete_match;
    }
    void Match::set_complete_match (bool value)
    {
        complete_match = value;
    }

    
    void Match::add (MatchData match)
    {
        matches.push_back(match);
    }
    //void Match::add (MatchData& match)
    //{
    //    matches.push_back(match);
    //}
    

    const MatchData& Match::at (const unsigned int i) const
    {
        return matches.at(i);
    }
    
    const unsigned int Match::size() const
    {
        return matches.size();
    }
    
}   // namespace Murx
