// MoveTo.hxx - part of the murx project
//
// (c) 2004 by Kai Hildebrandt
//
// ---------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
// ---------------------------------------------------------------------

#ifndef MURX_MOVETO_HXX
#define MURX_MOVETO_HXX

#include <string>
#include <vector>
#include "Filter.hxx"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


namespace Murx
{
    class MoveTo : public Filter
    {
    private:
        // additional attribute for moveto filter rules
        std::string folder;

    public:
        MoveTo  ();
        MoveTo  (const char* expression, bool ignore_case,
                 bool negativity, bool only_check_body_lines,
                 std::string folder);
        // copy constructor
        MoveTo  (Filter& filter);
        ~MoveTo ();

        void        print      () const;
        std::string get_folder () const;
        void        set_folder (std::string folder);

    };

} /* namespace Murx */

#endif /* MURX_MOVETO_HXX */
