// SIGALRMHandler.cxx - part of the murx project
//
// (c) 2005 Kai Hildebrandt
//
// ---------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
// ---------------------------------------------------------------------


#include <csignal>     // SIGALRM
#include <csetjmp>     // siglongjmp()
#include <cassert>     // assert()

#include "EventHandler.hxx"
#include "SIGALRMHandler.hxx"

#ifndef logger_logfile
#define logger_logfile Murx::Logger::get_instance(Murx::Logger::Logfile)
#endif


sigjmp_buf Murx::SIGALRMHandler::curr_env;


// hook method
int Murx::SIGALRMHandler::handle_signal (int signum)
{
    // exits program if signal is not SIGALRM
    assert (signum == SIGALRM);

    // dirty jump
    siglongjmp (curr_env, signum);
}


sigjmp_buf* Murx::SIGALRMHandler::get_curr_env()
{
    return &curr_env;
}
