// Score.hxx - part of the murx project
//
// (c) 2004 by Kai Hildebrandt
//
// ---------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
// ---------------------------------------------------------------------

#ifndef MURX_SCORE_HXX
#define MURX_SCORE_HXX

#include <string>
#include <vector>
#include "Filter.hxx"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


namespace Murx
{
    class Score : public Filter
    {
    private:
        // additional attribute for score filter rules
        int        score;

    public:
        Score  ();
        Score  (const char* expression,
                bool        ignore_case,
                bool        negativity,
                bool        only_check_body_lines,
                int         score);
        // copy constructor
        Score  (Filter& filter);
        ~Score ();

        void print     () const;
        int  get_score () const;
        void set_score (int score);

    };

} /* namespace Murx */

#endif /* MURX_SCORE_HXX */
