/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse rcparse
#define yylex   rclex
#define yyerror rcerror
#define yylval  rclval
#define yychar  rcchar
#define yydebug rcdebug
#define yynerrs rcnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACCOUNT = 258,
     ACCOUNTS = 259,
     BODY = 260,
     BODYLINES = 261,
     ALLOW = 262,
     CASE = 263,
     DELETE_DUPLICATES = 264,
     DENY = 265,
     HEADERFILE = 266,
     HIGHSCORE = 267,
     IGNORE_CASE = 268,
     LOGFILE = 269,
     LOGLEVEL = 270,
     MAXLENGTH = 271,
     MAXSIZE_ALLOW = 272,
     MAXSIZE_DENY = 273,
     MOVETO = 274,
     NETLOG = 275,
     NONCONFORMANT = 276,
     NORMALIZE_SUBJECT = 277,
     PASSWORD = 278,
     PORT = 279,
     PROTOCOL = 280,
     SCORE = 281,
     SERVER = 282,
     SIZE = 283,
     TEST = 284,
     TIMEOUT = 285,
     USE_TLS = 286,
     USE_STARTTLS = 287,
     USER = 288,
     BLOCK_BEGIN = 289,
     BLOCK_END = 290,
     FINGERPRINT = 291,
     STRING = 292,
     INTEGER = 293,
     YES_OR_NO = 294,
     EQ = 295,
     NE = 296,
     LT = 297,
     GT = 298,
     PLUS = 299,
     MINUS = 300
   };
#endif
/* Tokens.  */
#define ACCOUNT 258
#define ACCOUNTS 259
#define BODY 260
#define BODYLINES 261
#define ALLOW 262
#define CASE 263
#define DELETE_DUPLICATES 264
#define DENY 265
#define HEADERFILE 266
#define HIGHSCORE 267
#define IGNORE_CASE 268
#define LOGFILE 269
#define LOGLEVEL 270
#define MAXLENGTH 271
#define MAXSIZE_ALLOW 272
#define MAXSIZE_DENY 273
#define MOVETO 274
#define NETLOG 275
#define NONCONFORMANT 276
#define NORMALIZE_SUBJECT 277
#define PASSWORD 278
#define PORT 279
#define PROTOCOL 280
#define SCORE 281
#define SERVER 282
#define SIZE 283
#define TEST 284
#define TIMEOUT 285
#define USE_TLS 286
#define USE_STARTTLS 287
#define USER 288
#define BLOCK_BEGIN 289
#define BLOCK_END 290
#define FINGERPRINT 291
#define STRING 292
#define INTEGER 293
#define YES_OR_NO 294
#define EQ 295
#define NE 296
#define LT 297
#define GT 298
#define PLUS 299
#define MINUS 300




/* Copy the first part of user declarations.  */
#line 28 "RCParser.yxx"

#include <string>
#include <iostream>
#include <cstdlib>   // calloc()
#include "i18n.hxx"
#include "Preferences.hxx"
#include "Account.hxx"
#include "Filter.hxx"
#include "Score.hxx"
#include "MoveTo.hxx"
#include "Exceptions.hxx"
#include "Utils.hxx"
#include "RCParser.hxx"


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


// global containers :-|
Murx::Account rc_account;
Murx::Filter  rc_filter;

// We want to give the Preferences object as parameter for yyparse.
//
// The use of YYPARSE_PARAM is obsolete but it is better than
// having a global object. We will change this if there is a better
// solution for it.
//
#undef YYPARSE_PARAM
#define YYPARSE_PARAM preferences

// alternative: global value :-|
//
// defined in the function/method that uses this parser
//extern Murx::Preferences* preferences;

// uncomment for debugging
//#define DEBUG_MODE
#undef DEBUG_MODE

// DEBUG mode set?
#ifdef DEBUG_MODE
#undef DEBUG_MSG
#define DEBUG_MSG(msg) \
    std::cerr << "DEBUG: " << msg << std::endl;
#else
#define DEBUG_MSG(msg) \
    ;
#endif

// defined in RCScanner.lxx
extern std::string sub_rcfile;
extern int         rc_line;
 

// some helper functions
static void add_action_rule       (void* preferences, const char* action_type,
                                   const char* affected_accounts, bool negativity);

static void add_score_rule        (void* preferences, int value,
                                   const char* affected_accounts, bool negativity);

static void add_moveto_rule       (void* preferences, const char* folder,
                                   const char* affected_accounts, bool negativity);

static void get_affected_accounts (void* preferences,
                                   std::vector<std::string>& accounts,
                                   const char* affected_accounts, bool negativity);

static void check_account         (void* preferences, const char* name);

static void create_error_message  (std::string& message);


// the scanner
FlexLexer* rclexer;

inline int yylex ()
{
    return (rclexer->rclex());
}


// the parser
int rcparse (void* preferences);

void rcerror (const char* error)
{
    std::string message = _("syntax error");
    create_error_message (message);

    throw (Murx::Exceptions::SyntaxError
           (message + _(" in line ")
            + Murx::Utils::int_to_string (rc_line+1)));
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 129 "RCParser.yxx"
{
    int   ival;
    char* sval;
}
/* Line 187 of yacc.c.  */
#line 299 "y.rctab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 312 "y.rctab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   276

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  32
/* YYNRULES -- Number of rules.  */
#define YYNRULES  85
/* YYNRULES -- Number of states.  */
#define YYNSTATES  193

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   300

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    54,    57,    59,
      63,    69,    71,    74,    78,    82,    86,    90,    94,    98,
     102,   106,   110,   112,   114,   117,   121,   124,   128,   132,
     137,   141,   146,   150,   154,   156,   159,   160,   162,   166,
     172,   181,   190,   195,   202,   212,   222,   227,   234,   244,
     254,   258,   262,   266,   270,   274,   278,   282,   286,   290,
     294,   298,   302,   307,   311,   315
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      47,     0,    -1,    -1,    47,    48,    -1,    55,    -1,    62,
      -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,    67,
      -1,    68,    -1,    69,    -1,    70,    -1,    71,    -1,    72,
      -1,    73,    -1,    74,    -1,    75,    -1,    76,    -1,    77,
      -1,    39,    -1,    37,    -1,    37,    -1,    38,    -1,    38,
      -1,    44,    38,    -1,    45,    38,    -1,    52,    -1,    54,
      44,    52,    -1,     3,    50,    34,    56,    35,    -1,    57,
      -1,    56,    57,    -1,    33,    40,    50,    -1,    23,    40,
      50,    -1,    27,    40,    50,    -1,    25,    40,    50,    -1,
      24,    40,    52,    -1,    30,    40,    52,    -1,    31,    40,
      49,    -1,    32,    40,    49,    -1,    36,    40,    50,    -1,
       7,    -1,    10,    -1,    40,    50,    -1,     8,    40,    50,
      -1,    41,    50,    -1,     8,    41,    50,    -1,     5,    40,
      50,    -1,     5,     8,    40,    50,    -1,     5,    41,    50,
      -1,     5,     8,    41,    50,    -1,    28,    42,    52,    -1,
      28,    43,    52,    -1,    59,    -1,    60,    59,    -1,    -1,
      29,    -1,    61,    58,    59,    -1,    61,    58,    34,    60,
      35,    -1,    61,    58,     4,    40,    50,    34,    60,    35,
      -1,    61,    58,     4,    41,    50,    34,    60,    35,    -1,
      61,    26,    53,    59,    -1,    61,    26,    53,    34,    60,
      35,    -1,    61,    26,    53,     4,    40,    50,    34,    60,
      35,    -1,    61,    26,    53,     4,    41,    50,    34,    60,
      35,    -1,    61,    19,    50,    59,    -1,    61,    19,    50,
      34,    60,    35,    -1,    61,    19,    50,     4,    40,    50,
      34,    60,    35,    -1,    61,    19,    50,     4,    41,    50,
      34,    60,    35,    -1,     6,    40,    52,    -1,     9,    40,
      49,    -1,    11,    40,    51,    -1,    12,    40,    52,    -1,
      13,    40,    49,    -1,    14,    40,    51,    -1,    15,    40,
      54,    -1,    16,    40,    52,    -1,    17,    40,    52,    -1,
      18,    40,    52,    -1,    20,    40,    51,    -1,    21,    40,
      10,    -1,    21,    40,    19,    50,    -1,    22,    40,    49,
      -1,    29,    40,    49,    -1,    30,    40,    52,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   196,   196,   197,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   219,   241,   283,   332,   335,   336,   337,   340,   344,
     350,   382,   383,   386,   401,   416,   431,   461,   469,   477,
     485,   493,   521,   522,   525,   562,   604,   641,   683,   720,
     762,   799,   841,   849,   860,   861,   865,   868,   874,   889,
     902,   928,   950,   961,   972,   993,  1014,  1033,  1052,  1079,
    1108,  1119,  1130,  1153,  1164,  1175,  1198,  1209,  1220,  1231,
    1242,  1265,  1278,  1300,  1311,  1322
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCOUNT", "ACCOUNTS", "BODY",
  "BODYLINES", "ALLOW", "CASE", "DELETE_DUPLICATES", "DENY", "HEADERFILE",
  "HIGHSCORE", "IGNORE_CASE", "LOGFILE", "LOGLEVEL", "MAXLENGTH",
  "MAXSIZE_ALLOW", "MAXSIZE_DENY", "MOVETO", "NETLOG", "NONCONFORMANT",
  "NORMALIZE_SUBJECT", "PASSWORD", "PORT", "PROTOCOL", "SCORE", "SERVER",
  "SIZE", "TEST", "TIMEOUT", "USE_TLS", "USE_STARTTLS", "USER",
  "BLOCK_BEGIN", "BLOCK_END", "FINGERPRINT", "STRING", "INTEGER",
  "YES_OR_NO", "EQ", "NE", "LT", "GT", "PLUS", "MINUS", "$accept",
  "commands", "command", "arg_bool", "arg_string", "arg_path",
  "arg_integer", "arg_score", "arg_sum", "account", "acc_commands",
  "acc_command", "action", "rule", "rules", "local_testmode", "filter",
  "bodylines", "del_duplicates", "headerfile", "highscore", "ignore_case",
  "logfile", "loglevel", "maxlength", "maxsize_allow", "maxsize_deny",
  "netlog", "nonconformant", "normalize", "testmode", "global_timeout", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    46,    47,    47,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    49,    50,    51,    52,    53,    53,    53,    54,    54,
      55,    56,    56,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    58,    58,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    60,    60,    61,    61,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    74,    75,    76,    77
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     3,
       5,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     2,     3,     2,     3,     3,     4,
       3,     4,     3,     3,     1,     2,     0,     1,     3,     5,
       8,     8,     4,     6,     9,     9,     4,     6,     9,     9,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    56,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,     0,     3,
       4,     0,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,    43,     0,     0,     0,
       0,    24,    70,    21,    71,    23,    72,    73,    74,    75,
      28,    76,    77,    78,    79,    80,    81,     0,    83,    84,
      85,     0,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    58,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    31,     0,    82,     0,     0,    66,
      26,    27,     0,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    54,     0,    44,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    32,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      48,    50,    45,    47,    52,    53,    59,    55,    34,    37,
      36,    35,    38,    39,    40,    33,    41,     0,     0,    67,
       0,     0,    63,     0,     0,    49,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    60,    61,    68,
      69,    64,    65
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,    19,    64,    39,    66,    62,    85,    71,    20,
     103,   104,    59,   124,   125,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -70
static const yytype_int16 yypact[] =
{
     -70,   225,   -70,   -33,   -30,   -15,   -12,    -6,    -3,     3,
       5,    11,    14,    21,    31,    33,    38,    41,    42,   -70,
     -70,   197,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -27,
      53,    57,    61,    53,    57,    61,    53,    53,    53,    53,
      61,    -8,    57,    57,    53,   -70,   -70,   -33,   -26,    12,
     240,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,    55,   -70,   -70,   -70,   -70,   -70,   -33,   -70,   -70,
     -70,   110,   -70,    63,    74,   124,   -17,     7,     9,    13,
       1,   -33,   -33,   -70,    60,    77,    79,    80,    81,    90,
      95,    97,    99,   226,   -70,    53,   -70,    17,     1,   -70,
     -70,   -70,    28,     1,   -70,   -33,   -33,    36,   -33,   -33,
     -33,   -33,    53,    53,   -70,    62,   -70,   -70,   -33,    53,
     -33,   -33,    53,    57,    57,   -33,   -33,   -70,   -70,   -70,
     -33,   -33,   126,   -33,   -33,   128,   106,   107,   -33,   -33,
     -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,   -70,   -70,   -70,   -70,   -70,   -70,   108,   109,   -70,
     111,   112,   -70,     1,     1,   -70,   -70,     1,     1,     1,
       1,   152,   154,   168,   170,   178,   192,   -70,   -70,   -70,
     -70,   -70,   -70
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -70,   -70,   -70,   -39,   -56,   -42,   -16,   -70,   -70,   -70,
     -70,    44,   -70,   -59,   -69,   -70,   -70,   -70,   -70,   -70,
     -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,   -70
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      93,    81,    76,    69,    38,    68,    87,    60,    75,    88,
      40,    77,    82,    78,    79,   117,    86,    87,    83,    84,
      88,   106,   109,   115,   116,    41,   114,    67,    42,    89,
      70,    72,    73,    74,    43,   126,   127,    44,    80,   142,
      89,    91,    92,    45,   145,    46,    90,   118,   119,   120,
     121,    47,    91,    92,    48,   122,   123,   140,   141,   146,
     147,    49,   150,   151,   152,   153,   157,    87,   143,   144,
      88,    50,   158,    51,   160,   161,   148,   149,    52,   165,
     166,    53,    54,   157,   167,   168,   157,   170,   171,   139,
      89,    61,   175,   176,   163,   164,    63,   156,    65,   105,
     128,   110,    91,    92,   181,   182,   154,   155,   183,   184,
     185,   186,   111,   159,   107,    87,   162,   129,    88,   130,
     131,   132,   157,   157,   157,   157,   157,   157,   112,    87,
     133,    87,    88,    87,    88,   134,    88,   135,    89,   136,
     173,   174,   177,   178,   108,   179,   180,   138,     0,     0,
      91,    92,    89,     0,    89,     0,    89,    87,   113,    87,
      88,   169,    88,   172,    91,    92,    91,    92,    91,    92,
       0,     0,     0,    87,     0,    87,    88,     0,    88,     0,
      89,     0,    89,    87,     0,     0,    88,   187,     0,   188,
       0,     0,    91,    92,    91,    92,    89,    87,    89,     0,
      88,     0,     0,   189,    55,   190,    89,    56,    91,    92,
      91,    92,     0,   191,     0,     0,    57,     0,    91,    92,
      89,     0,     0,    58,     0,     2,     0,   192,     3,     0,
       0,     4,    91,    92,     5,     0,     6,     7,     8,     9,
      10,    11,    12,    13,     0,    14,    15,    16,     0,    94,
      95,    96,     0,    97,    17,    18,    98,    99,   100,   101,
       0,   137,   102,    94,    95,    96,     0,    97,     0,     0,
      98,    99,   100,   101,     0,     0,   102
};

static const yytype_int16 yycheck[] =
{
      59,    57,    10,    45,    37,    44,     5,    34,    50,     8,
      40,    19,    38,    52,    53,     8,     4,     5,    44,    45,
       8,    77,    81,    40,    41,    40,    85,    43,    40,    28,
      46,    47,    48,    49,    40,    91,    92,    40,    54,   108,
      28,    40,    41,    40,   113,    40,    34,    40,    41,    40,
      41,    40,    40,    41,    40,    42,    43,    40,    41,   115,
     116,    40,   118,   119,   120,   121,   125,     5,    40,    41,
       8,    40,   128,    40,   130,   131,    40,    41,    40,   135,
     136,    40,    40,   142,   140,   141,   145,   143,   144,   105,
      28,    38,   148,   149,   133,   134,    39,    35,    37,    44,
      40,    38,    40,    41,   173,   174,   122,   123,   177,   178,
     179,   180,    38,   129,     4,     5,   132,    40,     8,    40,
      40,    40,   181,   182,   183,   184,   185,   186,     4,     5,
      40,     5,     8,     5,     8,    40,     8,    40,    28,    40,
      34,    34,    34,    34,    34,    34,    34,   103,    -1,    -1,
      40,    41,    28,    -1,    28,    -1,    28,     5,    34,     5,
       8,    35,     8,    35,    40,    41,    40,    41,    40,    41,
      -1,    -1,    -1,     5,    -1,     5,     8,    -1,     8,    -1,
      28,    -1,    28,     5,    -1,    -1,     8,    35,    -1,    35,
      -1,    -1,    40,    41,    40,    41,    28,     5,    28,    -1,
       8,    -1,    -1,    35,     7,    35,    28,    10,    40,    41,
      40,    41,    -1,    35,    -1,    -1,    19,    -1,    40,    41,
      28,    -1,    -1,    26,    -1,     0,    -1,    35,     3,    -1,
      -1,     6,    40,    41,     9,    -1,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    20,    21,    22,    -1,    23,
      24,    25,    -1,    27,    29,    30,    30,    31,    32,    33,
      -1,    35,    36,    23,    24,    25,    -1,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    47,     0,     3,     6,     9,    11,    12,    13,    14,
      15,    16,    17,    18,    20,    21,    22,    29,    30,    48,
      55,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    37,    50,
      40,    40,    40,    40,    40,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    40,     7,    10,    19,    26,    58,
      34,    38,    52,    39,    49,    37,    51,    52,    49,    51,
      52,    54,    52,    52,    52,    51,    10,    19,    49,    49,
      52,    50,    38,    44,    45,    53,     4,     5,     8,    28,
      34,    40,    41,    59,    23,    24,    25,    27,    30,    31,
      32,    33,    36,    56,    57,    44,    50,     4,    34,    59,
      38,    38,     4,    34,    59,    40,    41,     8,    40,    41,
      40,    41,    42,    43,    59,    60,    50,    50,    40,    40,
      40,    40,    40,    40,    40,    40,    40,    35,    57,    52,
      40,    41,    60,    40,    41,    60,    50,    50,    40,    41,
      50,    50,    50,    50,    52,    52,    35,    59,    50,    52,
      50,    50,    52,    49,    49,    50,    50,    50,    50,    35,
      50,    50,    35,    34,    34,    50,    50,    34,    34,    34,
      34,    60,    60,    60,    60,    60,    60,    35,    35,    35,
      35,    35,    35
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 21:
#line 220 "RCParser.yxx"
    {
                    DEBUG_MSG ("arg_bool: begin");

                    std::string str = (yyvsp[(1) - (1)].sval);
                    Murx::Utils::chop (str);

                    if (str == "yes")
                    {
                        (yyval.ival) = 1;   // true
                    }
                    else
                    {
                        (yyval.ival) = 0;   // false
                    }
                    
                    free ((yyvsp[(1) - (1)].sval));

                    DEBUG_MSG ("arg_bool: end");
                }
    break;

  case 22:
#line 242 "RCParser.yxx"
    {
                    DEBUG_MSG ("arg_string: begin");

                    char*       new_str = 0;
                    std::string str     = (yyvsp[(1) - (1)].sval);

                    // eliminate leading and trailing "
                    Murx::Utils::chop (str);

                    // if string is not empty...
                    if (str.length() > 0)
                    {
                        // ...allocate memory...
                        new_str = (char*) calloc (str.length() + 1,
                                                  sizeof (char));

                        // ...and copy string to new buffer
                        for (unsigned int i = 0; i < str.length(); i++)
                        {
                            new_str[i] = str[i];
                        }

                        // ****  IMPORTANT  ****
                        //
                        // Because of a NULL pointer as possible return value
                        // chop(), arg_string has to be checked.
                        //
                        // Only if arg_string is not NULL it could be added
                        // and finally freed.

                        DEBUG_MSG ("alloc (string): '" + static_cast<std::string> (new_str) + "'");

                        (yyval.sval) = new_str;                        
                    }

                    free ((yyvsp[(1) - (1)].sval));

                    DEBUG_MSG ("arg_string: end");
                }
    break;

  case 23:
#line 284 "RCParser.yxx"
    {
                    DEBUG_MSG ("arg_path: begin");

                    // in addition to arg_string above,
                    // we are supporting environment variables
                    // and command substitutions here
                    
                    char        *new_str = 0;
                    std::string  str     = (yyvsp[(1) - (1)].sval);

                    // eliminate leading and trailing "
                    Murx::Utils::chop (str);

                    // if string is not empty...
                    if (str.length() > 0)
                    {
                        // expand variables and command substitutions
                        Murx::Utils::expand_path (str,rc_line);

                        // ...allocate memory...
                        new_str = (char*) calloc (str.length() + 1,
                                                  sizeof (char));

                        // ...and copy string to new buffer
                        for (unsigned int i = 0; i < str.length(); i++)
                        {
                            new_str[i] = str[i];
                        }

                        // ****  IMPORTANT  ****
                        //
                        // Because of a NULL pointer as possible return value
                        // chop(), arg_string has to be checked.
                        //
                        // Only if arg_path is not NULL it could be added
                        // and finally freed.

                        DEBUG_MSG ("alloc (path): '" + static_cast<std::string> (new_str) + "'");

                        (yyval.sval) = new_str;
                    }

                    free ((yyvsp[(1) - (1)].sval));

                    DEBUG_MSG ("arg_path: end");
                }
    break;

  case 24:
#line 332 "RCParser.yxx"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 25:
#line 335 "RCParser.yxx"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 26:
#line 336 "RCParser.yxx"
    { (yyval.ival) =  (yyvsp[(2) - (2)].ival); }
    break;

  case 27:
#line 337 "RCParser.yxx"
    { (yyval.ival) = -(yyvsp[(2) - (2)].ival); }
    break;

  case 28:
#line 341 "RCParser.yxx"
    {
                    (yyval.ival) = (yyvsp[(1) - (1)].ival);
                }
    break;

  case 29:
#line 345 "RCParser.yxx"
    {
                    (yyval.ival) = (yyvsp[(1) - (3)].ival) + (yyvsp[(3) - (3)].ival);
                }
    break;

  case 30:
#line 351 "RCParser.yxx"
    {
                    DEBUG_MSG ("account: begin");

                    if ((yyvsp[(2) - (5)].sval) == 0)
                    {
                        std::string message = _("no account name given");
                        create_error_message (message);
                        throw (Murx::Exceptions::EmptyString
                               ( message + _(" near line ")
                                 + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    rc_account.set_name ((yyvsp[(2) - (5)].sval));

                    check_account (preferences,(yyvsp[(2) - (5)].sval));

                    // account definition complete

                    static_cast<Murx::Preferences*>
                        (preferences)->add_account (rc_account);

                    rc_account.clear();

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(2) - (5)].sval)));

                    free ((yyvsp[(2) - (5)].sval));   // arg_string

                    DEBUG_MSG ("account: end");
                }
    break;

  case 33:
#line 387 "RCParser.yxx"
    {
                    DEBUG_MSG ("user: begin");

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        rc_account.set_user ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_string
                    }

                    DEBUG_MSG ("user: end");
                }
    break;

  case 34:
#line 402 "RCParser.yxx"
    {
                    DEBUG_MSG ("password: begin");

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        rc_account.set_password ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_string
                    }

                    DEBUG_MSG ("password: end");
                }
    break;

  case 35:
#line 417 "RCParser.yxx"
    {
                    DEBUG_MSG ("server: begin");

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        rc_account.set_server ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_string
                    }

                    DEBUG_MSG ("server: end");
                }
    break;

  case 36:
#line 432 "RCParser.yxx"
    {
                    DEBUG_MSG ("protocol: begin");

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        std::string protocol = (yyvsp[(3) - (3)].sval);

                        // transform string to lower case
                        Murx::Utils::tolower (protocol);
                        
                        // store protocol in account object
                        rc_account.set_protocol (protocol);

                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_string
                    }
                    else
                    {
                        std::string message = _("unknown protocol");
                        create_error_message (message);

                        throw (Murx::Exceptions::UnknownProtocol
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    DEBUG_MSG ("protocol: end");
                }
    break;

  case 37:
#line 462 "RCParser.yxx"
    {
                    DEBUG_MSG ("port: begin");

                    rc_account.set_port ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("port: end");
                }
    break;

  case 38:
#line 470 "RCParser.yxx"
    {
                    DEBUG_MSG ("local timeout: begin");

                    rc_account.set_timeout ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("local timeout: end");
                }
    break;

  case 39:
#line 478 "RCParser.yxx"
    {
                    DEBUG_MSG ("use_tls: begin");

                    rc_account.set_use_tls ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("use_tls: end");
                }
    break;

  case 40:
#line 486 "RCParser.yxx"
    {
                    DEBUG_MSG ("use_starttls: begin");

                    rc_account.set_use_starttls ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("use_starttls: end");
                }
    break;

  case 41:
#line 494 "RCParser.yxx"
    {
                    DEBUG_MSG ("fingerprint: begin");

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        if (Murx::Utils::check_fingerprint ((yyvsp[(3) - (3)].sval)))
                        {
                            rc_account.set_fingerprint ((yyvsp[(3) - (3)].sval));
                        }
                        else
                        {
                            std::string message = _("malformed fingerprint");
                            create_error_message (message);
                            throw (Murx::Exceptions::InvalidFingerprint
                                   (message + _(" in line ")
                                    + Murx::Utils::int_to_string (rc_line+1)));
                        }

                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_string
                    }

                    DEBUG_MSG ("fingerprint: end");
                }
    break;

  case 42:
#line 521 "RCParser.yxx"
    { (yyval.sval) = (yyvsp[(1) - (1)].sval); }
    break;

  case 43:
#line 522 "RCParser.yxx"
    { (yyval.sval) = (yyvsp[(1) - (1)].sval); }
    break;

  case 44:
#line 526 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (= string): begin");

                    /* add rule: default case, equal */
                    try
                    {
                        rc_filter.add_rule
                            ((yyvsp[(2) - (2)].sval),
                             static_cast<Murx::Preferences*> (preferences)->get_ignore_case(),
                             false, false);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(2) - (2)].sval)));

                    free ((yyvsp[(2) - (2)].sval));   // arg_string

                    DEBUG_MSG ("rule (= string): end");
                }
    break;

  case 45:
#line 563 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (case = string): begin");

                    /* add rule: case-(in)sensitive, equal */
                    bool icase = false;

                    // CASE = "nocase"?
                    if (strlen ((yyvsp[(1) - (3)].sval)) == 6)
                        icase = true;

                    try
                    {
                        rc_filter.add_rule ((yyvsp[(3) - (3)].sval),icase,false,false);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    free ((yyvsp[(1) - (3)].sval));   // CASE ("case" or "nocase")

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                    free ((yyvsp[(3) - (3)].sval));   // arg_string

                    DEBUG_MSG ("rule (case = string): end");
                }
    break;

  case 46:
#line 605 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (<> string): begin");

                    /* add rule: default case, not equal */
                    try
                    {
                        rc_filter.add_rule
                            ((yyvsp[(2) - (2)].sval),
                             static_cast<Murx::Preferences*> (preferences)->get_ignore_case(),
                             true,false);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(2) - (2)].sval)));

                    free ((yyvsp[(2) - (2)].sval));   // arg_string

                    DEBUG_MSG ("rule (<> string): begin");
                }
    break;

  case 47:
#line 642 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (case <> string): begin");

                    /* add rule: case-(in)sensitive, not equal */
                    bool icase = false;

                    // CASE = "nocase"?
                    if (strlen ((yyvsp[(1) - (3)].sval)) == 6)
                        icase = true;

                    try
                    {
                        rc_filter.add_rule ((yyvsp[(3) - (3)].sval),icase,true,false);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    free ((yyvsp[(1) - (3)].sval));   // CASE ("case" or "nocase")

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                    free ((yyvsp[(3) - (3)].sval));   // arg_string

                    DEBUG_MSG ("rule (case <> string): end");
                }
    break;

  case 48:
#line 684 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (= string): begin");

                    /* add rule: default case, equal */
                    try
                    {
                        rc_filter.add_rule
                            ((yyvsp[(3) - (3)].sval),
                             static_cast<Murx::Preferences*> (preferences)->get_ignore_case(),
                             false,true);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                    free ((yyvsp[(3) - (3)].sval));   // arg_string

                    DEBUG_MSG ("rule (= string): end");
                }
    break;

  case 49:
#line 721 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (case = string): begin");

                    /* add rule: case-(in)sensitive, equal */
                    bool icase = false;

                    // CASE = "nocase"?
                    if (strlen ((yyvsp[(2) - (4)].sval)) == 6)
                        icase = true;

                    try
                    {
                        rc_filter.add_rule ((yyvsp[(4) - (4)].sval),icase,false,true);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    free ((yyvsp[(2) - (4)].sval));   // CASE ("case" or "nocase")

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(4) - (4)].sval)));

                    free ((yyvsp[(4) - (4)].sval));   // arg_string

                    DEBUG_MSG ("rule (case = string): end");
                }
    break;

  case 50:
#line 763 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (<> string): begin");

                    /* add rule: default case, not equal */
                    try
                    {
                        rc_filter.add_rule
                            ((yyvsp[(3) - (3)].sval),
                             static_cast<Murx::Preferences*> (preferences)->get_ignore_case(),
                             true,true);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                    free ((yyvsp[(3) - (3)].sval));   // arg_string

                    DEBUG_MSG ("rule (<> string): begin");
                }
    break;

  case 51:
#line 800 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (case <> string): begin");

                    /* add rule: case-(in)sensitive, not equal */
                    bool icase = false;

                    // CASE = "nocase"?
                    if (strlen ((yyvsp[(2) - (4)].sval)) == 6)
                        icase = true;

                    try
                    {
                        rc_filter.add_rule ((yyvsp[(4) - (4)].sval),icase,true,true);
                    }
                    catch (Murx::Exceptions::EmptyPattern& e)
                    {
                        std::string message = _("empty pattern");
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }
                    catch (Murx::Exceptions::RegExCompilationError& e)
                    {
                        std::string message = e.what();
                        create_error_message (message);

                        throw (Murx::Exceptions::RegExCompilationError
                               (message + _(" in line ")
                                + Murx::Utils::int_to_string (rc_line+1)));
                    }

                    free ((yyvsp[(2) - (4)].sval));   // CASE ("case" or "nocase")

                    DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(4) - (4)].sval)));

                    free ((yyvsp[(4) - (4)].sval));   // arg_string

                    DEBUG_MSG ("rule (case <> string): end");
                }
    break;

  case 52:
#line 842 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (size < int): begin");

                    rc_filter.set_maxsize ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("rule (size < int): end");
                }
    break;

  case 53:
#line 850 "RCParser.yxx"
    {
                    DEBUG_MSG ("rule (size > int): begin");

                    rc_filter.set_minsize ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("rule (size > int): end");
                }
    break;

  case 56:
#line 865 "RCParser.yxx"
    {
                    // default // rc_filter.set_testmode (false);
                }
    break;

  case 57:
#line 869 "RCParser.yxx"
    {
                    rc_filter.set_testmode (true);
                }
    break;

  case 58:
#line 875 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (action rule): begin");

                    // ALLOW and DENY rules

                    // this rule have an effect on all accounts

                    // call helper
                    add_action_rule (preferences,(yyvsp[(2) - (3)].sval),"all",false);

                    free ((yyvsp[(2) - (3)].sval));   // action ("ALLOW" or "DENY")

                    DEBUG_MSG ("filter (actrion rule): end");
                }
    break;

  case 59:
#line 890 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (action { rules }): begin");

                    // this rule have an effect on all accounts

                    // call helper
                    add_action_rule (preferences,(yyvsp[(2) - (5)].sval),"all",false);

                    free ((yyvsp[(2) - (5)].sval));   // action ("ALLOW" or "DENY")

                    DEBUG_MSG ("filter (action { rules }): end");
                }
    break;

  case 60:
#line 903 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (action accounts = string { rules }): begin");

                    // these rules have only an effect on accounts in list ($4)

                    // call helper
                    DEBUG_MSG ("  adding action rule: begin");

                    add_action_rule (preferences,(yyvsp[(2) - (8)].sval),(yyvsp[(5) - (8)].sval),false);

                    DEBUG_MSG ("  adding action rule: end");

                    free ((yyvsp[(2) - (8)].sval));   // action ("ALLOW" or "DENY")
                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(5) - (8)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(5) - (8)].sval)));

                        free ((yyvsp[(5) - (8)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (action accounts = string { rules }): end");
                }
    break;

  case 61:
#line 929 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (action accounts <> string { rules }): begin");

                    // these rules have only an effect on accounts in list ($4)

                    // call helper
                    add_action_rule (preferences,(yyvsp[(2) - (8)].sval),(yyvsp[(5) - (8)].sval),true);

                    free ((yyvsp[(2) - (8)].sval));   // action ("ALLOW" or "DENY")
                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(5) - (8)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(5) - (8)].sval)));

                        free ((yyvsp[(5) - (8)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (action accounts <> string { rules }): end");
                }
    break;

  case 62:
#line 951 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (score int rule): begin");

                    // this rule have an effect on all accounts

                    // call helper
                    add_score_rule (preferences,(yyvsp[(3) - (4)].ival),"all",false);

                    DEBUG_MSG ("filter (score int rule): end");
                }
    break;

  case 63:
#line 962 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (score int { rules }): begin");

                    // this rule have an effect on all accounts

                    // call helper
                    add_score_rule (preferences,(yyvsp[(3) - (6)].ival),"all",false);

                    DEBUG_MSG ("filter (score int { rules }): end");
                }
    break;

  case 64:
#line 973 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (score int accounts = string { rules }): begin");

                    // these rules have only an effect on accounts in list ($5)

                    // call helper
                    add_score_rule (preferences,(yyvsp[(3) - (9)].ival),(yyvsp[(6) - (9)].sval),false);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(6) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(6) - (9)].sval)));

                        free ((yyvsp[(6) - (9)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (score int accounts = string { rules }): end");
                }
    break;

  case 65:
#line 994 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (score int accounts <> string { rules }): begin");

                    // these rules have only an effect on accounts in list ($5)

                    // call helper
                    add_score_rule (preferences,(yyvsp[(3) - (9)].ival),(yyvsp[(6) - (9)].sval),true);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(6) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(6) - (9)].sval)));

                        free ((yyvsp[(6) - (9)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (score int accounts <> string { rules }): end");
                }
    break;

  case 66:
#line 1015 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (moveto string rule): begin");

                    // this rule have an effect on all accounts

                    // call helper
                    add_moveto_rule (preferences,(yyvsp[(3) - (4)].sval),"all",false);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(3) - (4)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (4)].sval)));

                        free ((yyvsp[(3) - (4)].sval));   // arg_string
                    }

                    DEBUG_MSG ("filter (moveto string rule): end");
                }
    break;

  case 67:
#line 1034 "RCParser.yxx"
    {
                    DEBUG_MSG ("filter (moveto string { rules }): begin");

                    // this rule have an effect on all accounts

                    // call helper
                    add_moveto_rule (preferences,(yyvsp[(3) - (6)].sval),"all",false);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(3) - (6)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (6)].sval)));

                        free ((yyvsp[(3) - (6)].sval));   // arg_string
                    }

                    DEBUG_MSG ("filter (moveto string { rules }): end");
                }
    break;

  case 68:
#line 1053 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (moveto string accounts = string { rules }): begin");

                    // these rules have only an effect on accounts in list ($5)

                    // call helper
                    add_moveto_rule (preferences,(yyvsp[(3) - (9)].sval),(yyvsp[(6) - (9)].sval),false);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(3) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (9)].sval)));

                        free ((yyvsp[(3) - (9)].sval));   // arg_string
                    }
                    if ((yyvsp[(6) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(6) - (9)].sval)));

                        free ((yyvsp[(6) - (9)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (moveto string accounts = string { rules }): end");
                }
    break;

  case 69:
#line 1080 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (moveto string accounts <> string { rules }): begin");

                    // these rules have only an effect on accounts in list ($5)

                    // call helper
                    add_moveto_rule (preferences,(yyvsp[(3) - (9)].sval),(yyvsp[(6) - (9)].sval),true);

                    // extra handling for arg_string (can be NULL)
                    if ((yyvsp[(3) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(3) - (9)].sval)));

                        free ((yyvsp[(3) - (9)].sval));   // arg_string
                    }
                    if ((yyvsp[(6) - (9)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(6) - (9)].sval)));

                        free ((yyvsp[(6) - (9)].sval));   // arg_string
                    }

                    DEBUG_MSG
                        ("filter (moveto string accounts <> string { rules }): end");
                }
    break;

  case 70:
#line 1109 "RCParser.yxx"
    {
                    DEBUG_MSG ("bodylines = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_body_lines ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("bodylines = int: end");
                }
    break;

  case 71:
#line 1120 "RCParser.yxx"
    {
                    DEBUG_MSG ("delete_duplicates = bool: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_delete_duplicates ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("delete_duplicates = bool: end");
                }
    break;

  case 72:
#line 1131 "RCParser.yxx"
    {
                    DEBUG_MSG ("headerfile = path: begin");
                    
                    // ****  IMPORTANT  ****
                    //
                    // Only if arg_path is not NULL it could be added
                    // and finally freed.

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        static_cast<Murx::Preferences*>
                            (preferences)->set_headerfile ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (path): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_path
                    }

                    DEBUG_MSG ("headerfile = path: end");
                }
    break;

  case 73:
#line 1154 "RCParser.yxx"
    {
                    DEBUG_MSG ("highscore = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_highscore ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("highscore = int: end");
                }
    break;

  case 74:
#line 1165 "RCParser.yxx"
    {
                    DEBUG_MSG ("ignore_case = bool: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_ignore_case ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("ignore_case = bool: end");
                }
    break;

  case 75:
#line 1176 "RCParser.yxx"
    {
                    DEBUG_MSG ("logfile = path: begin");
                    
                    // ****  IMPORTANT  ****
                    //
                    // Only if arg_path is not NULL it could be added
                    // and finally freed.

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        static_cast<Murx::Preferences*>
                            (preferences)->set_logfile ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (path): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_path
                    }

                    DEBUG_MSG ("logfile = path: end");
                }
    break;

  case 76:
#line 1199 "RCParser.yxx"
    {
                    DEBUG_MSG ("loglevel = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_loglevel ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("loglevel = int: end");
                }
    break;

  case 77:
#line 1210 "RCParser.yxx"
    {
                    DEBUG_MSG ("maxlength = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_maxlength ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("maxlength = int: end");
                }
    break;

  case 78:
#line 1221 "RCParser.yxx"
    {
                    DEBUG_MSG ("maxsize_allow = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_maxsize_allow ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("maxsize_allow = int: end");
                }
    break;

  case 79:
#line 1232 "RCParser.yxx"
    {
                    DEBUG_MSG ("maxsize_deny = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_maxsize_deny ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("maxsize_deny = int: end");
                }
    break;

  case 80:
#line 1243 "RCParser.yxx"
    {
                    DEBUG_MSG ("netlog = path: begin");
                    
                    // ****  IMPORTANT  ****
                    //
                    // Only if arg_path is not NULL it could be added
                    // and finally freed.

                    if ((yyvsp[(3) - (3)].sval) != 0)
                    {
                        static_cast<Murx::Preferences*>
                            (preferences)->set_netlog ((yyvsp[(3) - (3)].sval));

                        DEBUG_MSG ("freed (path): " + static_cast<std::string> ((yyvsp[(3) - (3)].sval)));

                        free ((yyvsp[(3) - (3)].sval));   // arg_path
                    }

                    DEBUG_MSG ("netlog = path: end");
                }
    break;

  case 81:
#line 1266 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (deny nonconformant): begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_nonconformant_action ("DENY");

                    free ((yyvsp[(3) - (3)].sval));

                    DEBUG_MSG
                        ("filter (deny nonconformant): end");
                }
    break;

  case 82:
#line 1279 "RCParser.yxx"
    {
                    DEBUG_MSG
                        ("filter (moveto folder nonconformant): begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_nonconformant_action ("MOVETO");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_nonconformant_folder ((yyvsp[(4) - (4)].sval));

                    if ((yyvsp[(4) - (4)].sval) != 0)
                    {
                        DEBUG_MSG ("freed (string): " + static_cast<std::string> ((yyvsp[(4) - (4)].sval)));

                        free ((yyvsp[(4) - (4)].sval));
                    }

                    DEBUG_MSG
                        ("filter (moveto folder nonconformant): end");
                }
    break;

  case 83:
#line 1301 "RCParser.yxx"
    {
                    DEBUG_MSG ("normalize = bool: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_normalize_subject ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("normalize = bool: end");
                }
    break;

  case 84:
#line 1312 "RCParser.yxx"
    {
                    DEBUG_MSG ("testmode = bool: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_testmode ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("testmode = bool: end");
                }
    break;

  case 85:
#line 1323 "RCParser.yxx"
    {
                    DEBUG_MSG ("(global) timeout = int: begin");

                    static_cast<Murx::Preferences*>
                        (preferences)->set_global_timeout ((yyvsp[(3) - (3)].ival));

                    DEBUG_MSG ("(global) timeout = int: end");
                }
    break;


/* Line 1267 of yacc.c.  */
#line 2933 "y.rctab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 1333 "RCParser.yxx"


//
// definition of the helper functions
//

static void add_action_rule (void* preferences, const char* action_type,
                             const char* affected_accounts, bool negativity)
{
    // check for empty accountlist
    if (affected_accounts == 0)
    {
        std::string message = _("no account list given");
        create_error_message (message);
        throw (Murx::Exceptions::EmptyString
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    Murx::Preferences& pref = *static_cast<Murx::Preferences*> (preferences);

    // accounts stores a list of account names
    // in which this filter should be stored
    std::vector<std::string> accounts;

    DEBUG_MSG ("get_affected_accounts (...): begin");

    get_affected_accounts (preferences, accounts, affected_accounts, negativity);

    DEBUG_MSG ("get_affected_accounts (...): end");

    // This check is necessary if a rule was defined
    // before any account definitons.
    if (accounts.size())
    {
        if ( strcmp (action_type,"ALLOW") == 0 )
        {
            // add filter reference to matching accounts
            for (unsigned int i = 0; i < accounts.size(); i++)
            {
                pref.get_account(accounts[i],rc_line).add_allow_rule(rc_filter);
            }
        }
        else
        {
            // DENY rule
            
            // add filter reference to matching accounts
            for (unsigned int i = 0; i < accounts.size(); i++)
            {
                pref.get_account(accounts[i],rc_line).add_deny_rule(rc_filter);
            }
        }
    }
    else
    {
        // filter defined before any account definitions

        std::string message = _("filter needs at least one preceeding account definition");
        create_error_message (message);
        throw (Murx::Exceptions::AccountNotFound
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    // clear container
    rc_filter.clear();
}
    
    
static void add_score_rule (void* preferences, int value,
                            const char* affected_accounts, bool negativity)
{
    // check for empty accountlist
    if (affected_accounts == 0)
    {
        std::string message = _("no account list given");
        create_error_message (message);
        throw (Murx::Exceptions::EmptyString
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    Murx::Preferences& pref = *static_cast<Murx::Preferences*> (preferences);

    // accounts stores a list of account names
    // in which this filter should be stored
    std::vector<std::string> accounts;
    get_affected_accounts (preferences, accounts, affected_accounts, negativity);

    // This check is necessary if a rule was defined
    // before any account definitons.
    if (accounts.size())
    {
        // copy filter attributes in new Score object
        Murx::Score score (rc_filter);
    
        score.set_testmode (rc_filter.get_testmode());
        
        score.set_score (value);
        
        //pref.add_score_rule (score);
        
        // add filter reference to matching accounts
        for (unsigned int i = 0; i < accounts.size(); i++)
        {
            pref.get_account(accounts[i],rc_line).add_score_rule(score);
        }
        
    }
    else
    {
        // filter defined before any account definitions

        std::string message = _("filter needs at least one preceeding account definition");
        create_error_message (message);
        throw (Murx::Exceptions::AccountNotFound
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    // clear container (no longer used, we copied it into Score object)
    rc_filter.clear();
}


static void add_moveto_rule (void* preferences, const char* folder,
                             const char* affected_accounts, bool negativity)
{
    // check for empty accountlist
    if (affected_accounts == 0)
    {
        std::string message = _("no account list given");
        create_error_message (message);
        throw (Murx::Exceptions::EmptyString
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    Murx::Preferences& pref = *static_cast<Murx::Preferences*> (preferences);

    // accounts stores a list of account names
    // in which this filter should be stored
    std::vector<std::string> accounts;
    get_affected_accounts (preferences, accounts, affected_accounts, negativity);

    // This check is necessary if a rule was defined before any account definitons.
    if (accounts.size())
    {
        // copy filter attributes in new MoveTo object
        Murx::MoveTo moveto (rc_filter);
    
        moveto.set_testmode (rc_filter.get_testmode());

        moveto.set_folder (folder);
    
        //pref.add_moveto_rule (moveto);
    
        // add filter reference to matching accounts
        for (unsigned int i = 0; i < accounts.size(); i++)
        {
            pref.get_account(accounts[i],rc_line).add_moveto_rule(moveto);
        }
    }
    else
    {
        // filter defined before any account definitions

        std::string message = _("filter needs at least one preceeding account definition");
        create_error_message (message);
        throw (Murx::Exceptions::AccountNotFound
               (message + _(" near line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }

    // clear container (no longer used, we copied it into MoveTo object)
    rc_filter.clear();
}


// get a list of all accounts which should be affected by the actual
// filter
//
static void get_affected_accounts (void *preferences,
                                   std::vector<std::string>& accounts,
                                   const char* affected_accounts,
                                   bool negativity)
{
    Murx::Preferences& pref = *static_cast<Murx::Preferences*> (preferences);

    // get all accounts from preferences
    const std::vector<Murx::Account>& all_accounts = pref.get_accounts();

    if (strcmp (affected_accounts, "all") != 0)
    {
        // separate account names
        Murx::Utils::split (affected_accounts,',',accounts);

        if (negativity == false)
        {
            // nothing else to do
        }
        else
        {    // negativity == true

            // expensive copy!
            std::vector<std::string> new_accounts = accounts;

            // clear account name vector
            accounts.clear();

            // check every account against given account names
            for (unsigned int i = 0; i < all_accounts.size(); i++)
            {
                unsigned int j;

                for (j = 0; j < new_accounts.size(); j++)
                {
                    if (all_accounts[i].get_name() == new_accounts[j])
                    {
                        // at least one name matches, do not add to list
                        j = 0;
                        break;
                    }
                }

                if (j == new_accounts.size())
                {
                    // no match, add account name to list
                    accounts.push_back (all_accounts[i].get_name());
                }
            }
        }
    }
    else
    {    // affected_accounts == "all"

        // clear account name vector
        accounts.clear();

        if (negativity == true)
        {
            // makes no sense: ACCOUNTS <> "all"

            std::string message = _("account list will be empty");
            create_error_message (message);
            throw (Murx::Exceptions::EmptyString
                   (message + _(" near line ")
                    + Murx::Utils::int_to_string (rc_line+1)));
        }

        // add every account name to vector
        for (unsigned int i = 0; i < all_accounts.size(); i++)
        {
            accounts.push_back (all_accounts[i].get_name());
        }
    }
}


static void check_account (void* preferences, const char* name)
{
    Murx::Preferences& pref = *static_cast<Murx::Preferences*> (preferences);


    // check for duplicate account name

    // get all accounts from preferences
    const std::vector<Murx::Account>& all_accounts = pref.get_accounts();

    for (unsigned int i = 0; i < all_accounts.size(); i++)
    {
        if (all_accounts[i].get_name() == name)
        {
            throw (Murx::Exceptions::NameAlreadyExists
                   (_("account name already exists: ")
                    + static_cast<std::string> (name)));
        }
    }


    // check for completeness

    // an account must have at least login, password and server
    // for which we can not provide default values

    if ((   rc_account.get_user    ()).empty()
        || (rc_account.get_password()).empty()
        || (rc_account.get_server  ()).empty())
    {
        throw (Murx::Exceptions::AccountDefinitionIncomplete
               (_("incomplete account definition: ")
                + static_cast<std::string> (name)));
    }


    // set global timeout if not set yet

    if (rc_account.get_timeout() == 0)
    {
        rc_account.set_timeout (pref.get_global_timeout());
    }

    // setting of default values
    // (only values which can't be set via the constructor of Account)

    // check, if the port hasn't been set and if protocol is either
    // "imaps" or "pop3s". then it will be changed to "imap" or "pop3".

    if (rc_account.get_protocol() == "pop3")
    {
        if (rc_account.get_port() == 0)
            rc_account.set_port (110);
    }
    else if (rc_account.get_protocol() == "imap")
    {
        if (rc_account.get_port() == 0)
            rc_account.set_port (143);
    }
    else if (rc_account.get_protocol() == "pop3s")
    {
        rc_account.set_protocol ("pop3");

        if (rc_account.get_port() == 0)
            rc_account.set_port (995);
    }
    else if (rc_account.get_protocol() == "imaps")
    {
        rc_account.set_protocol ("imap");

        if (rc_account.get_port() == 0)
            rc_account.set_port (993);
    }
    else
    {
        std::string message = _("unknown protocol");
        create_error_message (message);
        throw (Murx::Exceptions::UnknownProtocol
               (message + _(" in line ")
                + Murx::Utils::int_to_string (rc_line+1)));
    }
}


static void create_error_message (std::string& message)
{
    // It is possible that an error occurs in another file than
    // the main rcfile. We have to check if we are in an included
    // file and append this file information to the error string.

    if (sub_rcfile.length() > 0)
    {
        message = message + _(" in rcfile ") + sub_rcfile;
    }
    else
    {
        message = message + _(" in main rcfile");
    }
}

